#define _WIN32_DCOM // assurer la prsence des dclarations propres  COM
#include "../Commun/Somme_h.h" // dclaration de ISomme
#include "../Commun/UUID_Fabriques.h" // UUID de la fabrique
#include "ChargeurCOM.h"
#include <iostream>
int main ()
{
   ChargeurCOM chcom;
   IUnknown *pUnk; // instancier le composant et obtenir un IUnknown*
   HRESULT hr = CoCreateInstance
                   (CLSID_FabriqueSomme, 0, CLSCTX_INPROC_SERVER,
                    IID_IUnknown, reinterpret_cast<void **> (&pUnk));
   if (FAILED (hr)) // erreur lors de l'instanciation du composant
   {
      std::cerr << "Echec de CoCreateInstance(), code " << hr << std::endl;
      return -2;
   }
   ISomme *pSomme; // obtenir le ISomme*
   hr = pUnk->QueryInterface (IID_ISomme, reinterpret_cast<void **> (&pSomme)); 
   pUnk->Release (); // librer le IUnknown*
   if (FAILED (hr))
   {
      std::cerr << "L'interface ISomme n'est pas exposee" << std::endl;
      return -3;
   }
   int LaSomme;
   hr = pSomme->Somme (2, 3, & LaSomme); // utiliser le ISomme*
   if (SUCCEEDED (hr))
      std::cout << "Somme de 2 et de 3 (via ISomme): " << LaSomme << std::endl;
   pSomme -> Release (); // librer le ISomme*
} // main ()
