// Fichier: ServeurSomme.cpp
#include "../Commun/UUID_Fabriques.h" // UUID de FabriqueSomme
#include "Registry.h" // RegisterServer(), UnregisterServer()
#include <string>
#include "GestionnaireDeVerrou.h"
#include "FabriqueSomme.h"


// Utilitaires de support au contexte
const std::string
   SRV_NOMFICH = "ServeurSomme.dll"
,  SRV_DESCR   = "Composant interne dmonstrateur"
,  SRV_NOM     = "Composant.Somme.InProc"
,  SRV_VERSION = "Composant.Somme.InProc.1"
;

HRESULT __stdcall DllRegisterServer ()
{
   return RegisterServer (SRV_NOMFICH,
                          CLSID_FabriqueSomme,
                          SRV_DESCR,
                          SRV_NOM,
                          SRV_VERSION,
                          0 );
}
HRESULT __stdcall DllUnregisterServer ()
{
   return UnregisterServer (CLSID_FabriqueSomme,
                            SRV_NOM,
                            SRV_VERSION);
}

HRESULT __stdcall DllGetClassObject (REFCLSID clsid, REFIID riid, void **ppv)
{
   if (clsid != CLSID_FabriqueSomme)
   {
      return CLASS_E_CLASSNOTAVAILABLE;
   }
   // Instanciation de la fabrique
   FabriqueSomme *pFab = new FabriqueSomme;
   if (pFab == 0)
      return E_OUTOFMEMORY;
   // riid est probablement IID_IClassFactory
   HRESULT hr = pFab->QueryInterface (riid, ppv);
   pFab->Release ();
   return hr;
}

HRESULT __stdcall DllCanUnloadNow ()
{
   return ((GestionnaireDeVerrou::GetInstance ()->EstVide ())? S_OK : S_FALSE);
}
